package com.zbf.system.service.impl;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl; //添加
import com.zbf.common.utils.DateUtils;
import com.zbf.common.utils.uuid.IdUtils;
import com.zbf.system.domain.TCallNotice;
import com.zbf.system.mapper.TCallNoticeMapper;
import com.zbf.system.service.ITCallNoticeService;
import com.zbf.system.websocket.WebSocketUsers;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author tony
 * @date 2024-07-11
 */
@Service
public class TCallNoticeServiceImpl extends ServiceImpl<TCallNoticeMapper, TCallNotice> implements ITCallNoticeService //修改
{
    @Autowired
    private TCallNoticeMapper tCallNoticeMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public TCallNotice selectTCallNoticeById(String id)
    {
        return tCallNoticeMapper.selectTCallNoticeById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     *
     * @param tCallNotice 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<TCallNotice> selectTCallNoticeList(TCallNotice tCallNotice)
    {
        return tCallNoticeMapper.selectTCallNoticeList(tCallNotice);
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param tCallNotice 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int insertTCallNotice(TCallNotice tCallNotice)
    {
        tCallNotice.setCreateTime(DateUtils.getNowDate());
        return tCallNoticeMapper.insertTCallNotice(tCallNotice);
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param tCallNotice 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateTCallNotice(TCallNotice tCallNotice)
    {
                tCallNotice.setUpdateTime(DateUtils.getNowDate());
        return tCallNoticeMapper.updateTCallNotice(tCallNotice);
    }

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteTCallNoticeByIds(String[] ids)
    {
        return tCallNoticeMapper.deleteTCallNoticeByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteTCallNoticeById(String id)
    {
        return tCallNoticeMapper.deleteTCallNoticeById(id);
    }


    /**
     * 批量禁用
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int disabledTCallNoticeByIds(String[] ids) {
        return tCallNoticeMapper.disabledTCallNoticeByIds(ids);
    }

    /**
     * 批量启用
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int enableTCallNoticeByIds(String[] ids) {
        return tCallNoticeMapper.enableTCallNoticeByIds(ids);
    }

    /**
     * 修改状态
     *
     * @param tCallNotice 工序管理主键
     * @return 结果
     */
    @Override
    public int updateStatus(TCallNotice tCallNotice) {
        return tCallNoticeMapper.updateTCallNotice(tCallNotice);
    }

    /**
     * 发送任务通知信息
     */
    @Override
    public void sendNotice(TCallNotice tCallNotice) {
        if (StringUtils.isEmpty(tCallNotice.getId())) {
            tCallNotice.setId(IdUtils.randomUUID());
        }
        
        tCallNoticeMapper.insertTCallNotice(tCallNotice);
        // 发送通知消息
        WebSocketUsers.sendMessageToUsersByText(tCallNotice);
    }

    @Override
    public int updateTaskStatus(TCallNotice tCallNotice) {
        return tCallNoticeMapper.updateTaskStatus(tCallNotice);
    }

}
